org.apache.commons.cli.avalon

## Class CLArgsParser

- java.lang.Object
- - org.apache.commons.cli.avalon.CLArgsParser

-     public final class CLArgsParser
      extends Object

  Parser for command line arguments. This parses command lines according to the standard (?) of GNU utilities. Note: This is still used in 1.1 libraries so do not add 1.2+ dependencies. Note that CLArgs uses a backing hashtable for the options index and so duplicate arguments are only returned by getArguments().
  See Also:
    `ParserControl`, `CLOption`, `CLOptionDescriptor`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CLArgsParser(String[] args, CLOptionDescriptor[] optionDescriptors)` Create a parser that deals with options and parses certain args.
    `CLArgsParser(String[] args, CLOptionDescriptor[] optionDescriptors, ParserControl control)` Create a parser that can deal with options and parses certain args.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `CLOption` | `getArgumentById(int id)` Retrieve the `CLOption` with specified id, or `null` if no command line option is found.
    `CLOption` | `getArgumentByName(String name)` Retrieve the `CLOption` with specified name, or `null` if no command line option is found.
    `Vector<CLOption>` | `getArguments()` Retrieve a list of options that were parsed from command list.
    `String` | `getErrorString()` Retrieve an error message that occurred during parsing if one existed.
    `String[]` | `getUnparsedArgs()` Retrieve an array of arguments that have not been parsed due to the parser halting.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CLArgsParser

          public CLArgsParser(String[] args,
                              CLOptionDescriptor[] optionDescriptors,
                              ParserControl control)

      Create a parser that can deal with options and parses certain args.
      Parameters:
        `args` - the args, typically that passed to the `public static void main(String[] args)` method.
        `optionDescriptors` - the option descriptors
        `control` - the parser control used determine behaviour of parser

    - #### CLArgsParser

          public CLArgsParser(String[] args,
                              CLOptionDescriptor[] optionDescriptors)

      Create a parser that deals with options and parses certain args.
      Parameters:
        `args` - the args
        `optionDescriptors` - the option descriptors

  - ### Method Detail

    - #### getUnparsedArgs

          public final String[] getUnparsedArgs()

      Retrieve an array of arguments that have not been parsed due to the parser halting.
      Returns:
        an array of unparsed args

    - #### getArguments

          public final Vector<CLOption> getArguments()

      Retrieve a list of options that were parsed from command list.
      Returns:
        the list of options

    - #### getArgumentById

          public final CLOption getArgumentById(int id)

      Retrieve the `CLOption` with specified id, or `null` if no command line option is found.
      Parameters:
        `id` - the command line option id
      Returns:
        the `CLOption` with the specified id, or `null` if no CLOption is found.
      See Also:
        `CLOption`

    - #### getArgumentByName

          public final CLOption getArgumentByName(String name)

      Retrieve the `CLOption` with specified name, or `null` if no command line option is found.
      Parameters:
        `name` - the command line option name
      Returns:
        the `CLOption` with the specified name, or `null` if no CLOption is found.
      See Also:
        `CLOption`

    - #### getErrorString

          public final String getErrorString()

      Retrieve an error message that occurred during parsing if one existed.
      Returns:
        the error string

Copyright © 1998-2019 Apache Software Foundation. All Rights Reserved.